#include "StyleView.ch"

FUNCTION ParseTMSchema( cFile, aClasses, aParts, aStates )

 LOCAL cSchema
 LOCAL cLine
 LOCAL n
 LOCAL nMax

   cSchema := MemoRead( cFile )
   IF Empty(cSchema) == .T.
      RETURN .F.
   ENDIF

   nMax := MlCount( cSchema, 80 )
   FOR n:=1 TO nMax
       cLine  := MemoLine( cSchema, 80, n )
       IF At("BEGIN_TM_CLASS_PARTS(", cLine) != 0
          ParseClassSection( cSchema, @n, aClasses, aParts, aStates )
       ELSEIF At("BEGIN_TM_PART_STATES(", cLine) != 0
          ParseStateSection( cSchema, @n, aClasses, aParts, aStates )
       ENDIF
   NEXT

RETURN aClasses


FUNCTION ParseClassSection( cSchema, nStartLine, aClasses, aParts, aStates )

 LOCAL cLine
 LOCAL nLine := nStartLine +1
 LOCAL nTmp
 LOCAL nPart
 LOCAL cPart
 LOCAL nIndex

    UNUSED( aStates )

    cLine  := MemoLine( cSchema, 80, nStartLine )
    nIndex := At("BEGIN_TM_CLASS_PARTS(", cLine)
    IF nIndex == 0
       RETURN .F.
    ENDIF
    AAdd( aClasses, AllTrim(SubStr(cLine,nIndex+21,At(")",cLine)-(nIndex+21))) )

    cLine  := MemoLine( cSchema, 80, nLine )
    DO WHILE At("END_TM_CLASS_PARTS()", cLine) == 0
       nTmp := At( "TM_PART(",cLine )
       IF nTmp == 0
          nLine++
          cLine  := MemoLine( cSchema, 80, nLine )
          LOOP                                        // (Read over comment)
       ENDIF
       cLine  := SubStr( cLine, nTmp +8 )
       nPart  := Val( SubStr(cLine, 1, At(",",cLine) -1 ) )
       cLine  := SubStr( cLine, At(",",cLine) +1 )    // (Read over Part Id)
       cLine  := SubStr( cLine, At(",",cLine) +1 )    // (Read over class abbrev.)
       cPart  := LTrim( SubStr( cLine, 1, At(")",cLine) -1) )

       AAdd( aParts, {aClasses[Len(aClasses)],cPart,nPart} )

       nLine++
       cLine  := MemoLine( cSchema, 80, nLine )
    ENDDO

    nStartLine := nLine

RETURN .T.


FUNCTION ParseStateSection( cSchema, nStartLine, aClasses, aParts, aStates )

 LOCAL cLine
 LOCAL nLine := nStartLine +1
 LOCAL cPart
 LOCAL nState
 LOCAL cState
 LOCAL nIndex

    UNUSED( aClasses )
    UNUSED( aParts )

    cLine  := MemoLine( cSchema, 80, nStartLine )
    nIndex := At("BEGIN_TM_PART_STATES(", cLine)
    IF nIndex == 0
       RETURN .F.
    ENDIF
    cPart := AllTrim( SubStr(cLine,nIndex+21,At(")",cLine)-(nIndex+21)) )
    AAdd( aStates, {cPart, {}} )

    cLine  := MemoLine( cSchema, 80, nLine )
    DO WHILE At("END_TM_PART_STATES()", cLine) == 0
       cLine  := SubStr( cLine, At("TM_STATE(",cLine) +9 )
       nState := Val( SubStr(cLine, At(",",cLine) -1) )
       cLine  := SubStr( cLine, At(",",cLine) +1)   // (Read over state id)
       cLine  := SubStr( cLine, At(",",cLine) +1)   // (Read over state abbrev.)
       cState := AllTrim( SubStr(cLine, 1, At(")",cLine) -1) )

       AAdd( aStates[Len(aStates)][2], {cState,nState} )

       nLine++
       cLine  := MemoLine( cSchema, 80, nLine )
    ENDDO

    nStartLine := nLine

RETURN .T.